package com.test

import static com.kms.katalon.core.checkpoint.CheckpointFactory.findCheckpoint
import static com.kms.katalon.core.testcase.TestCaseFactory.findTestCase
import static com.kms.katalon.core.testdata.TestDataFactory.findTestData
import static com.kms.katalon.core.testobject.ObjectRepository.findTestObject
import static com.kms.katalon.core.testobject.ObjectRepository.findWindowsObject

import com.kms.katalon.core.annotation.Keyword
import com.kms.katalon.core.checkpoint.Checkpoint
import com.kms.katalon.core.cucumber.keyword.CucumberBuiltinKeywords as CucumberKW
import com.kms.katalon.core.mobile.keyword.MobileBuiltInKeywords as Mobile
import com.kms.katalon.core.model.FailureHandling
import com.kms.katalon.core.testcase.TestCase
import com.kms.katalon.core.testdata.TestData
import com.kms.katalon.core.testobject.TestObject
import com.kms.katalon.core.webservice.keyword.WSBuiltInKeywords as WS
import com.kms.katalon.core.webui.keyword.WebUiBuiltInKeywords as WebUI
import com.kms.katalon.core.windows.keyword.WindowsBuiltinKeywords as Windows

import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

import internal.GlobalVariable

public class SubscribePublish {
	public static final MediaType JSON = MediaType.get("application/json; charset=utf-8");

	@Keyword
	def subscribe(String httpMessagingBridgeUrl, String topic, String callbackUrl) {
		println httpMessagingBridgeUrl + " " + topic + callbackUrl
		final OkHttpClient client = new OkHttpClient();
		RequestBody body = RequestBody.create(null, new byte[0]);
		Request request = new Request.Builder().url(httpMessagingBridgeUrl +
				"?topic=" + topic +"&url=" + callbackUrl).post(body).build();
		Response response = client.newCall(request).execute();
		println response.body().string()
		return true
	}
}
